
var database = require('./database');
var register_subscriber = require('./register_subscriber');

const express = require('express')
const app = express()
app.use(express.json());
const port = 3101
const host = 'http://localhost';

const chalk = require('chalk')

database.start().then(() => {
    app.post('/register', (req, res) => {
        console.log(`Received request at ${chalk.italic('\'/register\'')}`);
        register_subscriber(req.body).then((payload) => {
            if(payload == undefined) res.status(400).json('');
            else res.json(payload);
        })
        .catch((error) => {
            console.log(chalk.red(error));
            res.status(500).json(error);
        })
    })
    
    app.listen(port, () => {
      console.log(`Mail Subscription Service listening at ${chalk.cyan(`${host}:${port}`)}`);
    });
})